Take With Time
==============
A stream transformer that kills the stream after the set expiry time

Example
-------
```dart
import 'dart:async';
import 'package:take_with_time/take_with_time.dart';

main() {
  var controller  = new StreamController();
  var transformer = new TakeWithTime(new Duration(seconds: 5));
  var slice       = controller.stream.transform(transformer);
  var timer       = new Timer.periodic(new Duration(seconds: 1), (_) {
    controller.add("yay, data");
  });

  slice.listen(
    (data)       => print(data),
    onError: (e) => print("wat!?"),
    onDone: ()   => timer.cancel()
  );
}
```
