library take_with_time;

import 'dart:async';

class TakeWithTime<S, T> extends StreamEventTransformer {

  final Duration _duration;

  const TakeWithTime(this._duration);

  Stream<T> bind(Stream<S> stream) {
    var result       = new StreamController();
    var subscription = stream.listen(
      (S data)      => result.add(data),
      onError: (e)  => result.addError(e),
      onDone: ()    => result.close()
    );
    new Timer(this._duration, () {
      result.close();
      subscription.cancel();
    });
    return result.stream;
  }

}